/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.email.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.email.entity.EmailLayout;
import de.ivu.elect.business.email.entity.EmailLayoutUK;

public abstract class AbstractEmailLayoutDAO extends de.ivu.elect.jee.entity.AbstractDAO<EmailLayout,
        de.ivu.elect.business.email.entity.EmailLayoutPK
    , EmailLayoutUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractEmailLayoutDAO.class);

  public AbstractEmailLayoutDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.email.entity.EmailLayoutPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public EmailLayout findByPrimaryKey(
        de.ivu.elect.business.email.entity.EmailLayoutPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected EmailLayout findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(EmailLayout.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: AllOrderByBezeichnungNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: select o from EmailLayout o order by o.bezeichnung<br>
      * SQL: <br>
      */
     public java.util.List<EmailLayout> findByAllOrderByBezeichnung() {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  
                              return
                              getEntityManager().
                                createNamedQuery("EMAIL_LAYOUT.AllOrderByBezeichnung")
                                                            .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByAllOrderByBezeichnung - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("EmailLayout, findByAllOrderByBezeichnung - NonUniqueResultException, Parameter: "
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByAllOrderByBezeichnung(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: BezeichnungNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: select o from EmailLayout o where o.bezeichnung=?1<br>
      * SQL: <br>
      */
     public EmailLayout findByBezeichnung( @javax.annotation.Nonnull String bezeichnung) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  String bezeichnungCheckedAndAttached =  checkAndAttach(bezeichnung, String.class, "bezeichnung"); ;
		  
                              return
                    (EmailLayout)
                              getEntityManager().
                                createNamedQuery("EMAIL_LAYOUT.Bezeichnung")
                              .setParameter(1, bezeichnungCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByBezeichnung - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("EmailLayout, findByBezeichnung - NonUniqueResultException, Parameter: "
           + ", bezeichnung:'"+bezeichnung+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByBezeichnung(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: CountAllNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: select count(o) from EmailLayout o<br>
      * SQL: <br>
      */
     public java.lang.Long findByCountAll() {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("EMAIL_LAYOUT.CountAll")
                                                            .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByCountAll - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("EmailLayout, findByCountAll - NonUniqueResultException, Parameter: "
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByCountAll(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: CountVerwendungTypNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: select count(o) from EmailLayout o where o.verwendungTyp=?1<br>
      * SQL: <br>
      */
     public java.lang.Long findByCountVerwendungTyp( @javax.annotation.Nonnull de.ivu.elect.business.email.entity.EmailLayoutVerwendungType emailLayoutVerwendungType) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.email.entity.EmailLayoutVerwendungType emailLayoutVerwendungTypeCheckedAndAttached =  checkAndAttach(emailLayoutVerwendungType, de.ivu.elect.business.email.entity.EmailLayoutVerwendungType.class, "emailLayoutVerwendungType"); ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("EMAIL_LAYOUT.CountVerwendungTyp")
                              .setParameter(1, emailLayoutVerwendungTypeCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByCountVerwendungTyp - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("EmailLayout, findByCountVerwendungTyp - NonUniqueResultException, Parameter: "
           + ", emailLayoutVerwendungType:'"+emailLayoutVerwendungType+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByCountVerwendungTyp(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: VerwendungTypNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: select o from EmailLayout o where o.verwendungTyp=?1<br>
      * SQL: <br>
      */
     public java.util.List<EmailLayout> findByVerwendungTyp( @javax.annotation.Nonnull de.ivu.elect.business.email.entity.EmailLayoutVerwendungType emailLayoutVerwendungType) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.email.entity.EmailLayoutVerwendungType emailLayoutVerwendungTypeCheckedAndAttached =  checkAndAttach(emailLayoutVerwendungType, de.ivu.elect.business.email.entity.EmailLayoutVerwendungType.class, "emailLayoutVerwendungType"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("EMAIL_LAYOUT.VerwendungTyp")
                              .setParameter(1, emailLayoutVerwendungTypeCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByVerwendungTyp - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("EmailLayout, findByVerwendungTyp - NonUniqueResultException, Parameter: "
           + ", emailLayoutVerwendungType:'"+emailLayoutVerwendungType+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByVerwendungTyp(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: VerwendungTypWhereBezeichnungNotNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: update EmailLayout o set o.verwendungTyp=?2 where o.bezeichnung!=?1<br>
      * SQL: <br>
      */
     public Integer updateVerwendungTypWhereBezeichnungNot( @javax.annotation.Nonnull String bezeichnung,  @javax.annotation.Nonnull de.ivu.elect.business.email.entity.EmailLayoutVerwendungType emailLayoutVerwendungType) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  String bezeichnungCheckedAndAttached =  checkAndAttach(bezeichnung, String.class, "bezeichnung"); ;
		  			  de.ivu.elect.business.email.entity.EmailLayoutVerwendungType emailLayoutVerwendungTypeCheckedAndAttached =  checkAndAttach(emailLayoutVerwendungType, de.ivu.elect.business.email.entity.EmailLayoutVerwendungType.class, "emailLayoutVerwendungType"); ;
		  
                              return
                    (Integer)
                              getEntityManager().
                                createNamedQuery("EMAIL_LAYOUT.VerwendungTypWhereBezeichnungNot")
                              .setParameter(1, bezeichnungCheckedAndAttached)
                                        .setParameter(2, emailLayoutVerwendungTypeCheckedAndAttached)
                                                                      .executeUpdate();
                    
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("EmailLayout, updateVerwendungTypWhereBezeichnungNot - NonUniqueResultException, Parameter: "
           + ", bezeichnung:'"+bezeichnung+"'"
           + ", emailLayoutVerwendungType:'"+emailLayoutVerwendungType+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".updateVerwendungTypWhereBezeichnungNot(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.email.entity.EmailLayoutUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.email.entity.EmailLayoutUK uk,
        de.ivu.elect.business.email.entity.EmailLayoutPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

   public de.ivu.elect.business.email.entity.EmailLayout findByUK(de.ivu.elect.business.email.entity.EmailLayoutUK uk){

    try {
     return (de.ivu.elect.business.email.entity.EmailLayout) getEntityManager().createNamedQuery("EMAIL_LAYOUT.UK")
                  .setParameter(1, uk
                .getBezeichnung ()  
              )
          .getSingleResult()
     ;
     } catch (NonUniqueResultException nure) {
        LOG.warn("EmailLayout, findByUK - NonUniqueResultException, UK: " + uk);
        throw nure;
     }
  }
    
}